scrollText = "Hei instanssi!! This is a party prod made live at NordicFuzzCon 2020!! made in just about an hour on a sofa somewhere in the lobby of the clarion... .. .  * * *  Servas es Beidln!  Jyrki hier mit einem wunderbaren Scrollertext auf Deutsch, den keiner hier verstehen wird -- vielleicht :P  Gruesse gehen raus an rrerrNet und SVatG.  Man riecht sich auf der exzellenten Revision Osterdemoparty in Saarbrooklyn!  * * *  Hi there!! Lynn on da keyz!! bapping away at the keyboard trying to think of some stupid text to write for this scroller... hmm... well... NFC has been pretty good! It was my first con, and it's a strange experience after 15 years of demoparties... but it will definitely not be a last one!! I'm not here at instanssi, but you can be sure to find me (and others) at excellent parties such as Revision and Outline!! That's all from me for now... passing the keeb on... .. . Tervehdys! Taeaellae Neo tuttuun tapaan piirtelemaessae turreja ja loeytaemaessae lisaeae poerroeisiae scenettaejiae!! Mikae sun lempielaein on?"
socket = require("socket")
address, port = "valot.party", 9909

function love.load()

  local flags = { fullscreen = "true" }

  -- aim for a 1280x720 window, but fullscreen takes whatever the display is currently set to
  love.window.setMode(1280, 720, flags)

  -- figure out scaling ratio
  displayWidth, displayHeight = love.graphics.getDimensions()
  ratio = { width  = displayWidth  / 1280,
            height = displayHeight / 720   }
  print(string.format("We have a display of %dx%d -- scaling factor is %f x %f.", displayWidth, displayHeight, ratio.width, ratio.height))

  font = love.graphics.newFont("monof55.ttf", 80 * ratio.width)

  -- define sound
  audio = love.audio.newSource("ftgdemo_sounds.wav", "stream")
  audio:setLooping(true)
  audio:play()

  -- define gfx
  gfx1 = love.graphics.newImage("gfx/1.jpg")
  gfx2 = love.graphics.newImage("gfx/2.jpg")
  gfx3 = love.graphics.newImage("gfx/3.jpg")

  gfx = { { gfx = gfx1, r = 96,  g = 255, b = 0   },
          { gfx = gfx2, r = 255, g = 115, b = 0   },
          { gfx = gfx3, r = 255, g = 0,   b = 255 }
  }


  showImage = 1
  imgChange = 0
  
  -- setup for udp lights
  lightsLoad()
  -- set lights according to the first image
  updateLights()

  -- scroller stuff
  c = 0
  scrollStart = 1400 * ratio.width
  letterDistance = 60 * ratio.width
  shadowOffset = 10 * ratio.width
end

function lightsLoad()

	udp = socket.udp()
	udp:setpeername(address, port)

  -- get the IP address, as sendto() can not work with hostnames
  ip, port = udp:getpeername()
  print("lights.party happen at ", ip, " ", port)
  -- disconnect UDP socket again.  sendto() will do that every time we call it
  udp:setpeername('*')

end

function updateLights()
  local the_gfx = gfx[showImage]

	-- this part currently doesn't work

	-- this part needs to be in the beginning of every sent udp string
	dg = string.char(
     1, -- always one
     0, -- nicktag
     78, -- N
     69, -- E
     79, -- O
     0 -- nicktag end
 )

	-- this part defines a colour for all lights at the party
	for i=0,23 do 
		dg = dg..string.char( 
		1, -- always one
		i, -- number of lamp
		0, -- always zero
		the_gfx.r, --- RED
		the_gfx.g, --- GREEN
		the_gfx.b  --- BLUE
	)
	end

 -- sends the udp string
  print("emitting the colours ", the_gfx.r, the_gfx.g, the_gfx.b, " to ", ip, ":", port)
 udp:sendto(dg, ip, port)

end


function love.update()
  dt = love.timer.getDelta()
  c = c + dt * 100

  imgChange = imgChange + dt

  if imgChange > 3 then
    -- after roughly 3 seconds, change pic
    imgChange = 0

    showImage = showImage + 1
    

    if showImage > 3 then
      showImage = 1
    end
    
	-- changes lights when image updates
    updateLights()
    
  end

  if c > 16000 then
    love.event.quit()
  end

  if love.keyboard.isDown("q") or love.keyboard.isDown("escape") then
    love.event.quit()
  end
end


function love.draw()


  -- picture goes here!!  :D
  local the_gfx = gfx[showImage]

  love.graphics.setColor(the_gfx.r / 255, the_gfx.g / 255, the_gfx.b / 255, 1)

  love.graphics.draw(the_gfx.gfx, 0, 0, 0, ratio.width, ratio.height)

  -- scroller goes here!! :D

  love.graphics.setFont(font)
  love.graphics.setColor(255, 255, 255, 255)

  -- love.graphics.print(c, 5, 5)

  text = scrollText

  x = scrollStart - (c * 4) * ratio.width

  for i = 1, string.len(text) do

    y = math.sin((c / 64) + i / 8) * (displayHeight / 4) + (displayHeight / 2)

      love.graphics.setColor(0, 0, 0, .5)
      love.graphics.print(string.sub(text, i, i), x + (i * letterDistance) + shadowOffset, y + shadowOffset)

      love.graphics.setColor(1, 1, 1, 1)
      love.graphics.print(string.sub(text, i, i), (x + (i * letterDistance)), y)

    i = i + 1
  end

end
